bl_info = {
  "name": "cvELD_softimage",
  "author": "cvELD",
  "version": (1, 0, 0),
  "blender": (2, 80, 0),
  "location": "Softimageのショートカットに準じる",
  "support": "TESTING",
  "category": "UI",
  "warning" : "",
  "wiki_url": "",
  "tracker_url": "https://cveld.net/"
}


if "bpy" in locals():
    import imp
    imp.reload(si_subdiv)
    imp.reload(si_resetSRT)
    imp.reload(si_MoveComponent)

else:
    from . import si_subdiv
    from . import si_resetSRT
    from . import si_MoveComponent

import bpy
import rna_keymap_ui
from bpy.props import *
from bpy.types import Operator, AddonPreferences, Panel, PropertyGroup

# メニューを構築する関数
def menu_fn(self, context):
	self.layout.separator()
	self.layout.operator(si_subdiv.si_del_subdiv_OT_object.bl_idname)
	self.layout.operator(si_subdiv.si_add_subdiv_OT_object.bl_idname)
	self.layout.operator(si_subdiv.si_minus_subdiv_OT_object.bl_idname)
	self.layout.operator(si_resetSRT.si_resetSRT_OT_object.bl_idname)
	self.layout.operator(si_MoveComponent.si_MoveComponent_OT_object.bl_idname)



def update_register_Softimage(self, context):
	try:
		addon_prefs = bpy.context.preferences.addons[__name__].preferences
		if addon_prefs.keymap_Softimage:
			add_keymap_Softimage()
		else:
			remove_keymap_Softimage()
	except:
		pass
def update_register_CustomTools(self, context):
	try:
		addon_prefs = bpy.context.preferences.addons[__name__].preferences
		if addon_prefs.keymap_CustomTools:
			add_keymap_CustomTools()
		else:
			remove_keymap_CustomTools()
	except:
		pass


class KEYMAPSETL_MT_AddonPreferences(bpy.types.AddonPreferences):
	bl_idname = __name__

	# キーマップ
	keymap_Softimage        : BoolProperty(name = "Softimage",default=True,update = update_register_Softimage)
	keymap_CustomTools       : BoolProperty(name = "CustomTools",default=True,update = update_register_CustomTools)

	# タブ
	keymap_Softimage_tab   : BoolProperty(default=True)
	keymap_CustomTools_tab  : BoolProperty(default=True)

	def draw(self, context):
		layout = self.layout
		preferences = context.preferences
		addon_prefs = preferences.addons[__name__].preferences


		col = layout.column(align=True)
		row = col.row(align=True)
		row.prop(self, "keymap_Softimage")
		row.prop(self, "keymap_Softimage_tab", text="Softimage KeyMap", icon="EMPTY_ARROWS")

		if self.keymap_Softimage_tab:
			col = layout.column()
			kc = bpy.context.window_manager.keyconfigs.addon
			for km, kmi in keymap_Softimage:
				km = km.active()
				col.context_pointer_set("keymap", km)
				rna_keymap_ui.draw_kmi([], kc, km, kmi, col, 0)


		col = layout.column(align=True)
		row = col.row(align=True)
		row.prop(self, "keymap_CustomTools")
		row.prop(self, "keymap_CustomTools_tab", text="便利機能色々", icon="VIS_SEL_11")

		if self.keymap_CustomTools_tab:
			col = layout.column()
			kc = bpy.context.window_manager.keyconfigs.addon
			for km, kmi in keymap_CustomTools:
				km = km.active()
				col.context_pointer_set("keymap", km)
				rna_keymap_ui.draw_kmi([], kc, km, kmi, col, 0)


		row = layout.row(align=False)
		box = row.box()
		box.label(text="Sキーでカメラ操作をするにはAutoHotKeyが必要、解説記事に飛ぶ")
		box.operator("wm.url_open", text="cvELD.net",icon="URL").url = "https://cvELD.net"


classes = [
	KEYMAPSETL_MT_AddonPreferences,
    si_subdiv.si_del_subdiv_OT_object,
	si_subdiv.si_add_subdiv_OT_object,
	si_subdiv.si_minus_subdiv_OT_object,

	si_resetSRT.si_resetSRT_OT_object,

	si_MoveComponent.si_MoveComponent_OT_object,
	si_MoveComponent.si_MoveComponent1_OT_object,
	si_MoveComponent.si_MoveComponent2_OT_object,
	si_MoveComponent.si_MoveComponent3_OT_object,
]

# init内のキーマップ
keymap_Softimage = []
keymap_CustomTools = []




def kmi_props_setattr(kmi_props, attr, value):
	try:
		setattr(kmi_props, attr, value)
	except AttributeError:
		print("Warning: property '%s' not found in keymap item '%s'" %
			  (attr, kmi_props.__class__.__name__))
	except Exception as e:
		print("Warning: %r" % e)

def add_keymap_CustomTools():
	wm = bpy.context.window_manager

	if wm.keyconfigs.addon:
		addon_prefs = bpy.context.preferences.addons[__name__].preferences
		keynew = wm.keyconfigs.addon.keymaps.new

		km = keynew(name = 'Object Mode')
		kmi = km.keymap_items.new('outliner.si_toggle_hide', 'H', 'PRESS')
		kmi.active = True
		keymap_CustomTools.append((km, kmi))

		km = keynew(name = 'Outliner', space_type = 'OUTLINER')
		kmi = km.keymap_items.new('outliner.si_toggle_hide', 'H', 'PRESS')
		kmi.active = True
		keymap_CustomTools.append((km, kmi))

		km = keynew(name = 'Outliner', space_type = 'OUTLINER')
		kmi = km.keymap_items.new('outliner.visibility_toggle', 'J', 'PRESS')
		kmi.active = True
		keymap_CustomTools.append((km, kmi))




def add_keymap_Softimage():
	wm = bpy.context.window_manager

	if wm.keyconfigs.addon:
		addon_prefs = bpy.context.preferences.addons[__name__].preferences
		keynew = wm.keyconfigs.addon.keymaps.new


		#1
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_del_sudiv', 'NUMPAD_MINUS', 'PRESS' , ctrl = True )
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))

		#2
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_add_sudiv', 'NUMPAD_PLUS', 'PRESS')
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))

        #3
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_minus_sudiv', 'NUMPAD_MINUS', 'PRESS')
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))

        #si_ResetSRT
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_resetsrt', 'R', 'PRESS',ctrl = True ,shift = True )
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))

        #si_movecomponent
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_movecomponent', 'M', 'PRESS' )
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))

		#si_Active componetnt Vertex Edge Face
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_movecomponent1', 'T', 'ANY' )
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))
		#si_Active componetnt Vertex Edge Face
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_movecomponent2', 'E', 'ANY' )
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))
		#si_Active componetnt Vertex Edge Face
		km = keynew('3D View Generic', space_type='VIEW_3D', region_type='WINDOW', modal=False)
		kmi = km.keymap_items.new('object.si_movecomponent3', 'U', 'ANY' )
		kmi_props_setattr(kmi.properties, 'name', 'builtin.select_box')
		kmi.active = True
		keymap_Softimage.append((km, kmi))

def remove_keymap_Softimage():

	keymap_list = [
	keymap_Softimage
	]

	for l in keymap_list:
		for km, kmi in l:
			km.keymap_items.remove(kmi)

	for l in keymap_list:
		l.clear()

	for l in keymap_list:
		del l[:]

def remove_keymap_CustomTools():

	keymap_list = [
	keymap_CustomTools
	]

	for l in keymap_list:
		for km, kmi in l:
			km.keymap_items.remove(kmi)

	for l in keymap_list:
		l.clear()

	for l in keymap_list:
		del l[:]


def register():
	for cls in classes:
		bpy.utils.register_class(cls)
	add_keymap_Softimage()
	add_keymap_CustomTools()

def unregister():
	for cls in classes:
		bpy.utils.unregister_class(cls)

	remove_keymap_Softimage()
	remove_keymap_CustomTools()

	if __name__ == "__main__":
		register


# メイン処理
if __name__ == "__main__":
    register()