import bpy


def si_active_normal():
    for o in bpy.context.selected_objects:
        if o.type == 'MESH':
            bpy.ops.object.shade_smooth()
            o.data.use_auto_smooth = True
            o.data.auto_smooth_angle = 1.0472

def si_noactive_normal():
    for o in bpy.context.selected_objects:
        if o.type == 'MESH':
            bpy.ops.object.shade_flat()
            o.data.use_auto_smooth = False
            o.data.auto_smooth_angle = 0.523599

def delete_subdiv():
    for o in bpy.context.selected_objects:
        for m in o.modifiers:
            if(m.type == "SUBSURF"):
                o.modifiers.remove(m)
    return

def xsisubdiv(oL,oAdd):
    #サブディビモデファイアの名前が一致したらプレビューの数値を増やす
    for o in bpy.context.selected_objects:
        #メッシュか判定
        if o.type == 'MESH':
            #名称規則でSI_subdivが存在しなければ新規でモデファイア生成
            if o.modifiers.get("SI_subdiv") == None:
                #すでに知らん名前のサブディビモデファイアがあれば全てさよならグッバイ
                for m in o.modifiers:
                    if(m.type == "SUBSURF"):
                        o.modifiers.remove(m)
                oLevel =o.modifiers.new("SI_subdiv",type = "SUBSURF")
                oLevel.render_levels = oL
                oLevel.levels = oL
                print(o.name + " add SI_subdiv")
            #名称規則でSI_subdivが存在していれば、サブディビジョンレベルを＋１
            #ただし、知らん名前のSUBSURFがあれば放置
            else:
                for m in o.modifiers:
                    if(m.type == "SUBSURF" and m.name =="SI_subdiv"):
                        m.render_levels = m.render_levels+ oAdd
                        m.levels = m.levels+ oAdd
                        print(o.name + " subdiv level " + str(m.levels))
    #ビューのリフレッシュ
    bpy.context.scene.frame_current = bpy.context.scene.frame_current
    return


class si_del_subdiv_OT_object(bpy.types.Operator):
    bl_idname = "object.si_del_sudiv"
    bl_label = "サブディビジョン全削除"
    bl_description = "Softimage like Subdivision"
    bl_options = {'REGISTER', 'UNDO'} 

    def execute(self, context):
        delete_subdiv()
        si_noactive_normal()
        return {'FINISHED'}


class si_add_subdiv_OT_object(bpy.types.Operator):
    bl_idname = "object.si_add_sudiv"
    bl_label = "サブディビジョン追加"
    bl_description = "Softimage like Subdivision"
    bl_options = {'REGISTER', 'UNDO'} 

    def execute(self,context):
        si_active_normal()
        xsisubdiv(1,1)
        return {'FINISHED'}

class si_minus_subdiv_OT_object(bpy.types.Operator):
    bl_idname = "object.si_minus_sudiv"
    bl_label = "サブディビジョン減少"
    bl_description = "Softimage like Subdivision"
    bl_options = {'REGISTER', 'UNDO'} 

    def execute(self,context):
        xsisubdiv(1,-1)
        return {'FINISHED'}